/**
 * 
 */
package com.axemble.education.connectors.navigation;

import java.util.Collection;

import com.axemble.education.connectors.navigation.common.CommonNavigationServiceConnector;
import com.axemble.education.connectors.navigation.common.CommonNavigationServiceConnectorEditor;
import com.axemble.vdoc.sdk.interfaces.IProperty;
import com.axemble.vdoc.sdk.interfaces.IResourceController;
import com.axemble.vdp.utils.StringUtils;

/**
 * @author vlygeros
 *
 */
public class HideElementsServiceConnector extends CommonNavigationServiceConnector
{
	private static final long serialVersionUID = 3732832259233727245L;

	@Override
	protected void execute( IResourceController resourceController )
	{
		boolean value = ( (Boolean)getServiceDefinition().getValue( CommonNavigationServiceConnectorEditor.FIELD_VALUE ) ).booleanValue();

		String option = (String)getServiceDefinition().getValue( HideElementsServiceConnectorEditor.FIELD_ELEMENTS_CHOICES );
		switch ( option )
		{
			case HideElementsServiceConnectorEditor.OPTION_FROM_VALUE :
			{
				String stringMarkers = (String)getServiceDefinition().getValue( HideElementsServiceConnectorEditor.FIELD_ELEMENTS_VALUE );
				if ( StringUtils.isNotEmpty( stringMarkers ) )
				{
					stringMarkers = stringMarkers.trim();
					String[] markers = StringUtils.split( stringMarkers, "," );
					for ( int i = 0 ; i < markers.length ; i++ )
					{
						String marker = markers[i];
						resourceController.showBodyBlock( marker, !value );
					}
				}
			}
				break;
			case HideElementsServiceConnectorEditor.OPTION_FROM_FIELD :
			{
				Collection<IProperty> properties = (Collection<IProperty>)getServiceDefinition().getValue( CommonNavigationServiceConnectorEditor.FIELD_ELEMENTS_FIELD );
				if ( properties != null )
				{
					for ( IProperty property : properties )
						resourceController.setHidden( property.getName(), value );
				}
			}
				break;
		}
	}

}
