/**
 * 
 */
package com.axemble.education.connectors.navigation;

import com.axemble.education.connectors.navigation.common.CommonNavigationServiceConnectorEditor;
import com.axemble.vdp.ui.framework.components.events.ChangeEvent;
import com.axemble.vdp.ui.framework.components.listeners.ChangeListener;
import com.axemble.vdp.ui.framework.document.AbstractField;

/**
 * @author vlygeros
 *
 */
public class HideElementsServiceConnectorEditor extends CommonNavigationServiceConnectorEditor
{
	private static final long serialVersionUID = -4470877350672577596L;

	public final static String FIELD_ELEMENTS_CHOICES = "fldElementsChoices";
	public final static String FIELD_ELEMENTS_VALUE = "fldElementsValue";
	public final static String FIELD_ELEMENTS_FIELD = "fldElementsField";

	@Override
	public boolean onAfterLoad()
	{
		super.onAfterLoad();

		// parent folder
		AbstractField elementsChoices = this.getDocument().getAbstractFieldByName( FIELD_ELEMENTS_CHOICES );
		if ( elementsChoices == null )
			return false;

		String options = (String)elementsChoices.getValue();
		manageElementsChoices( options );

		elementsChoices.addChangeListener( new ChangeListener()
		{
			@Override
			public void onChange( ChangeEvent event )
			{
				String options = (String)( (AbstractField)event.getSource() ).getValue();
				manageElementsChoices( options );
			}
		} );

		return true;
	}
	void manageElementsChoices( String options )
	{
		if ( options == null )
		{
			getSheet().getPage( SYS_PAGE_PARAMETERS ).getSubSectionByName( SECTION_SETTINGS ).getEntryByName( FIELD_ELEMENTS_VALUE ).setHidden( true );
			getSheet().getPage( SYS_PAGE_PARAMETERS ).getSubSectionByName( SECTION_SETTINGS ).getEntryByName( FIELD_ELEMENTS_FIELD ).setHidden( true );
			return;
		}

		switch ( options )
		{
			case OPTION_FROM_VALUE :
				getSheet().getPage( SYS_PAGE_PARAMETERS ).getSubSectionByName( SECTION_SETTINGS ).getEntryByName( FIELD_ELEMENTS_VALUE ).setHidden( false );
				getSheet().getPage( SYS_PAGE_PARAMETERS ).getSubSectionByName( SECTION_SETTINGS ).getEntryByName( FIELD_ELEMENTS_FIELD ).setHidden( true );
				break;
			case OPTION_FROM_FIELD :
				getSheet().getPage( SYS_PAGE_PARAMETERS ).getSubSectionByName( SECTION_SETTINGS ).getEntryByName( FIELD_ELEMENTS_VALUE ).setHidden( true );
				getSheet().getPage( SYS_PAGE_PARAMETERS ).getSubSectionByName( SECTION_SETTINGS ).getEntryByName( FIELD_ELEMENTS_FIELD ).setHidden( false );
				break;
		}
	}
}
