/**
 * 
 */
package com.axemble.education.connectors.navigation.common;

import com.axemble.vdoc.sdk.connectors.BaseServiceConnectorEditor;
import com.axemble.vdoc.sdk.document.fields.SelectorField;
import com.axemble.vdoc.sdk.interfaces.IAction;
import com.axemble.vdoc.sdk.interfaces.IForm;
import com.axemble.vdoc.sdk.interfaces.IResourceDefinition;
import com.axemble.vdoc.sdk.interfaces.ITask;
import com.axemble.vdoc.sdk.interfaces.IWorkflow;
import com.axemble.vdoc.sdk.interfaces.ui.components.IPropertySelectorComponent;

/**
 * @author vlygeros
 *
 */
public class CommonNavigationServiceConnectorEditor extends BaseServiceConnectorEditor
{
	private static final long serialVersionUID = -4470877350672577596L;

	/****************************************************************************
	 * ALL SECTIONS
	 ***************************************************************************/
	public static final String SYS_PAGE_PARAMETERS = "inputManagement";
	public final static String SECTION_SETTINGS = "settings";

	/****************************************************************************
	 * COMMON FIELDS
	 ***************************************************************************/
	public final static String FIELD_ELEMENTS_FIELD = "fldElementsField";
	public final static String FIELD_VALUE = "fldValue";

	/****************************************************************************
	 * OPTIONS
	 ***************************************************************************/
	// common options
	public static final String OPTION_FROM_FIELD = "fromField";
	public static final String OPTION_FROM_VALUE = "fromValue";

	@Override
	public boolean onAfterLoad()
	{
		String parentContextUri = getParentContextUri();

		SelectorField elementsSelector = (SelectorField)getResourceController().getDefaultWidget( FIELD_ELEMENTS_FIELD );
		elementsSelector.getParameters().put( IPropertySelectorComponent.ContextKeys.CONTEXT_SCOPE, parentContextUri );

		return super.onAfterLoad();
	}
	protected String getParentContextUri()
	{
		Object parentContext = getParentContext();

		if ( parentContext instanceof IWorkflow )
			return ( (IWorkflow)parentContext ).getProtocolURI();
		else if ( parentContext instanceof IResourceDefinition )
			return ( (IResourceDefinition)parentContext ).getProtocolURI();
		else if ( parentContext instanceof ITask )
			return ( (ITask)parentContext ).getWorkflow().getProtocolURI();
		else if ( parentContext instanceof IAction )
			return ( (IAction)parentContext ).getTask().getWorkflow().getProtocolURI();
		else if ( parentContext instanceof IForm )
			return ( (IForm)parentContext ).getParentContext().getProtocolURI();

		return null;
	}
}
